// Copyright 2019-present Facebook Inc. All rights reserved.
// This source code is licensed under the Apache 2.0 license found
// in the LICENSE file in the root directory of this source tree.

// Code generated by entc, DO NOT EDIT.

package car

const (
	// Label holds the string label denoting the car type in the database.
	Label = "car"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldBeforeID holds the string denoting the before_id field in the database.
	FieldBeforeID = "before_id"
	// FieldAfterID holds the string denoting the after_id field in the database.
	FieldAfterID = "after_id"
	// FieldModel holds the string denoting the model field in the database.
	FieldModel = "model"
	// EdgeOwner holds the string denoting the owner edge name in mutations.
	EdgeOwner = "owner"
	// Table holds the table name of the car in the database.
	Table = "cars"
	// OwnerTable is the table that holds the owner relation/edge.
	OwnerTable = "cars"
	// OwnerInverseTable is the table name for the Pet entity.
	// It exists in this package in order to avoid circular dependency with the "pet" package.
	OwnerInverseTable = "pets"
	// OwnerColumn is the table column denoting the owner relation/edge.
	OwnerColumn = "pet_cars"
)

// Columns holds all SQL columns for car fields.
var Columns = []string{
	FieldID,
	FieldBeforeID,
	FieldAfterID,
	FieldModel,
}

// ForeignKeys holds the SQL foreign-keys that are owned by the "cars"
// table and are not defined as standalone fields in the schema.
var ForeignKeys = []string{
	"pet_cars",
}

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	for i := range ForeignKeys {
		if column == ForeignKeys[i] {
			return true
		}
	}
	return false
}

var (
	// BeforeIDValidator is a validator for the "before_id" field. It is called by the builders before save.
	BeforeIDValidator func(float64) error
	// AfterIDValidator is a validator for the "after_id" field. It is called by the builders before save.
	AfterIDValidator func(float64) error
	// IDValidator is a validator for the "id" field. It is called by the builders before save.
	IDValidator func(int) error
)
